// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package app_log

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/work/lib/api/workflow/workflow_models"
)

// PostAppLogsReader is a Reader for the PostAppLogs structure.
type PostAppLogsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostAppLogsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostAppLogsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostAppLogsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostAppLogsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostAppLogsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPostAppLogsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostAppLogsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewPostAppLogsOK creates a PostAppLogsOK with default headers values
func NewPostAppLogsOK() *PostAppLogsOK {
	return &PostAppLogsOK{}
}

/*
PostAppLogsOK describes a response with status code 200, with default header values.

Array of AppLogs
*/
type PostAppLogsOK struct {
	AccessControlAllowOrigin string

	Payload *workflow_models.AppLogResponse
}

// IsSuccess returns true when this post app logs o k response has a 2xx status code
func (o *PostAppLogsOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this post app logs o k response has a 3xx status code
func (o *PostAppLogsOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post app logs o k response has a 4xx status code
func (o *PostAppLogsOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this post app logs o k response has a 5xx status code
func (o *PostAppLogsOK) IsServerError() bool {
	return false
}

// IsCode returns true when this post app logs o k response a status code equal to that given
func (o *PostAppLogsOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the post app logs o k response
func (o *PostAppLogsOK) Code() int {
	return 200
}

func (o *PostAppLogsOK) Error() string {
	return fmt.Sprintf("[POST /applogs][%d] postAppLogsOK  %+v", 200, o.Payload)
}

func (o *PostAppLogsOK) String() string {
	return fmt.Sprintf("[POST /applogs][%d] postAppLogsOK  %+v", 200, o.Payload)
}

func (o *PostAppLogsOK) GetPayload() *workflow_models.AppLogResponse {
	return o.Payload
}

func (o *PostAppLogsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(workflow_models.AppLogResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostAppLogsUnauthorized creates a PostAppLogsUnauthorized with default headers values
func NewPostAppLogsUnauthorized() *PostAppLogsUnauthorized {
	return &PostAppLogsUnauthorized{}
}

/*
PostAppLogsUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type PostAppLogsUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *workflow_models.Error
}

// IsSuccess returns true when this post app logs unauthorized response has a 2xx status code
func (o *PostAppLogsUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post app logs unauthorized response has a 3xx status code
func (o *PostAppLogsUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post app logs unauthorized response has a 4xx status code
func (o *PostAppLogsUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this post app logs unauthorized response has a 5xx status code
func (o *PostAppLogsUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this post app logs unauthorized response a status code equal to that given
func (o *PostAppLogsUnauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the post app logs unauthorized response
func (o *PostAppLogsUnauthorized) Code() int {
	return 401
}

func (o *PostAppLogsUnauthorized) Error() string {
	return fmt.Sprintf("[POST /applogs][%d] postAppLogsUnauthorized  %+v", 401, o.Payload)
}

func (o *PostAppLogsUnauthorized) String() string {
	return fmt.Sprintf("[POST /applogs][%d] postAppLogsUnauthorized  %+v", 401, o.Payload)
}

func (o *PostAppLogsUnauthorized) GetPayload() *workflow_models.Error {
	return o.Payload
}

func (o *PostAppLogsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(workflow_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostAppLogsForbidden creates a PostAppLogsForbidden with default headers values
func NewPostAppLogsForbidden() *PostAppLogsForbidden {
	return &PostAppLogsForbidden{}
}

/*
PostAppLogsForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type PostAppLogsForbidden struct {
	AccessControlAllowOrigin string

	Payload *workflow_models.Error
}

// IsSuccess returns true when this post app logs forbidden response has a 2xx status code
func (o *PostAppLogsForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post app logs forbidden response has a 3xx status code
func (o *PostAppLogsForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post app logs forbidden response has a 4xx status code
func (o *PostAppLogsForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this post app logs forbidden response has a 5xx status code
func (o *PostAppLogsForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this post app logs forbidden response a status code equal to that given
func (o *PostAppLogsForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the post app logs forbidden response
func (o *PostAppLogsForbidden) Code() int {
	return 403
}

func (o *PostAppLogsForbidden) Error() string {
	return fmt.Sprintf("[POST /applogs][%d] postAppLogsForbidden  %+v", 403, o.Payload)
}

func (o *PostAppLogsForbidden) String() string {
	return fmt.Sprintf("[POST /applogs][%d] postAppLogsForbidden  %+v", 403, o.Payload)
}

func (o *PostAppLogsForbidden) GetPayload() *workflow_models.Error {
	return o.Payload
}

func (o *PostAppLogsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(workflow_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostAppLogsNotFound creates a PostAppLogsNotFound with default headers values
func NewPostAppLogsNotFound() *PostAppLogsNotFound {
	return &PostAppLogsNotFound{}
}

/*
PostAppLogsNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type PostAppLogsNotFound struct {
	AccessControlAllowOrigin string

	Payload *workflow_models.Error
}

// IsSuccess returns true when this post app logs not found response has a 2xx status code
func (o *PostAppLogsNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post app logs not found response has a 3xx status code
func (o *PostAppLogsNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post app logs not found response has a 4xx status code
func (o *PostAppLogsNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this post app logs not found response has a 5xx status code
func (o *PostAppLogsNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this post app logs not found response a status code equal to that given
func (o *PostAppLogsNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the post app logs not found response
func (o *PostAppLogsNotFound) Code() int {
	return 404
}

func (o *PostAppLogsNotFound) Error() string {
	return fmt.Sprintf("[POST /applogs][%d] postAppLogsNotFound  %+v", 404, o.Payload)
}

func (o *PostAppLogsNotFound) String() string {
	return fmt.Sprintf("[POST /applogs][%d] postAppLogsNotFound  %+v", 404, o.Payload)
}

func (o *PostAppLogsNotFound) GetPayload() *workflow_models.Error {
	return o.Payload
}

func (o *PostAppLogsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(workflow_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostAppLogsUnprocessableEntity creates a PostAppLogsUnprocessableEntity with default headers values
func NewPostAppLogsUnprocessableEntity() *PostAppLogsUnprocessableEntity {
	return &PostAppLogsUnprocessableEntity{}
}

/*
PostAppLogsUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PostAppLogsUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *workflow_models.Error
}

// IsSuccess returns true when this post app logs unprocessable entity response has a 2xx status code
func (o *PostAppLogsUnprocessableEntity) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post app logs unprocessable entity response has a 3xx status code
func (o *PostAppLogsUnprocessableEntity) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post app logs unprocessable entity response has a 4xx status code
func (o *PostAppLogsUnprocessableEntity) IsClientError() bool {
	return true
}

// IsServerError returns true when this post app logs unprocessable entity response has a 5xx status code
func (o *PostAppLogsUnprocessableEntity) IsServerError() bool {
	return false
}

// IsCode returns true when this post app logs unprocessable entity response a status code equal to that given
func (o *PostAppLogsUnprocessableEntity) IsCode(code int) bool {
	return code == 422
}

// Code gets the status code for the post app logs unprocessable entity response
func (o *PostAppLogsUnprocessableEntity) Code() int {
	return 422
}

func (o *PostAppLogsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[POST /applogs][%d] postAppLogsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PostAppLogsUnprocessableEntity) String() string {
	return fmt.Sprintf("[POST /applogs][%d] postAppLogsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PostAppLogsUnprocessableEntity) GetPayload() *workflow_models.Error {
	return o.Payload
}

func (o *PostAppLogsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(workflow_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostAppLogsInternalServerError creates a PostAppLogsInternalServerError with default headers values
func NewPostAppLogsInternalServerError() *PostAppLogsInternalServerError {
	return &PostAppLogsInternalServerError{}
}

/*
PostAppLogsInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type PostAppLogsInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *workflow_models.Error
}

// IsSuccess returns true when this post app logs internal server error response has a 2xx status code
func (o *PostAppLogsInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post app logs internal server error response has a 3xx status code
func (o *PostAppLogsInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post app logs internal server error response has a 4xx status code
func (o *PostAppLogsInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this post app logs internal server error response has a 5xx status code
func (o *PostAppLogsInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this post app logs internal server error response a status code equal to that given
func (o *PostAppLogsInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the post app logs internal server error response
func (o *PostAppLogsInternalServerError) Code() int {
	return 500
}

func (o *PostAppLogsInternalServerError) Error() string {
	return fmt.Sprintf("[POST /applogs][%d] postAppLogsInternalServerError  %+v", 500, o.Payload)
}

func (o *PostAppLogsInternalServerError) String() string {
	return fmt.Sprintf("[POST /applogs][%d] postAppLogsInternalServerError  %+v", 500, o.Payload)
}

func (o *PostAppLogsInternalServerError) GetPayload() *workflow_models.Error {
	return o.Payload
}

func (o *PostAppLogsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(workflow_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
